import java.util.*;
public class BinaererSuchbaum <Typ>{
  private Knoten <Typ> wurzel;
  public BinaererSuchbaum(){}

  public BinaererSuchbaum(int e){ // Typ e
    wurzel = new Knoten(e); 
  }

  public Knoten <Typ> gibWurzel(){
    return wurzel;
  }

  public Knoten <Typ> gibLinkenTeilbaum(){
    return wurzel.gibLinkenTeilbaum();
  }

  public Knoten <Typ> gibRechtenTeilbaum(){
    return wurzel.gibRechtenTeilbaum();
  }

  public boolean istLeer(){
    return wurzel==null;
  }

  public void ausgebenDatenInorder(){
    System.out.print(wurzel.returnDatenInorder());
  }

  public void ausgebenDatenPreorder(){
    wurzel.ausgebenDatenPreorder();  
  }

  public void ausgebenDatenPostorder(){
    wurzel.ausgebenDatenPostorder();  
  }

  public void ausgebenDatenLevelorder(){ // Ebene fuer Ebene ausgeben
    wurzel.ausgebenDatenLevelorder();
  }

  public void ausgebenBaum(){ // Baum auf Konsole ausgeben
    wurzel.ausgebenBaum();
  }

  public void einfuegenElement (int e){// sortiert e einfuegen
    if (wurzel==null){
      wurzel = new Knoten (e);
    }
    else wurzel.einfuegenElement(e);
  }

  public void erstelleBaumAusListe(String s){ // aus String erstellen
    String[] elemente = s.split(" "); // in Elemente aufspalten
    for(int i=0;i<elemente.length;i++){ // alle Elemente einfuegen
      einfuegenElement(Integer.parseInt(elemente[i]));
    }
  }

  public void erstelleBaumAusListeOptimal(String s){ // minimale Hoehe
    String[] elemente = s.split(" "); // in Elemente aufspalten
    List<Integer> werte = new ArrayList<>(); // Liste von Integern
    for(int i=0;i<elemente.length;i++){ // In die Liste einfuegen
      werte.add(Integer.parseInt(elemente[i]));
    }
    Collections.sort(werte); // Liste aufsteigend sortieren!
    einfuegenSortListe(werte); // Hilfsfunktion
  }

  public void erstelleBaumAusListeOptimal2(String s){ // Vorher Nachher Demo
    erstelleBaumAusListe(s); // Baum erstellen Vorher
    ausgebenBaum();
    String sortiert = wurzel.returnDatenInorder(); // Inorder ist sortiert
    System.out.println(sortiert);
    String[] elemente = sortiert.split(" ");
    List<Integer> werte = new ArrayList<>();
    for(int i=0;i<elemente.length;i++){
      werte.add(Integer.parseInt(elemente[i]));
    }
    wurzel=null;
    einfuegenSortListe(werte); // Hilfsfunktion
    ausgebenBaum();
  }

  public void einfuegenSortListe(List<Integer> l){ // teile und herrsche
    if (l.size()>0){ // wenn Liste nicht leer
      int m=l.size()/2; // Mitte der Liste
      einfuegenElement(l.get(m)); // mittleres Element einfuegen
      einfuegenSortListe(l.subList(0,m)); // unterer Rest: Index von 0 bis m-1
      einfuegenSortListe(l.subList(m+1,l.size())); // oberer Rest: Index von m+1 bis size()-1
    }
  }

  public void ausgeben2D(){ // Danke Sabine
    wurzel.baumAusgeben2D("", false, true);
  }

  public static void teste(){
    System.out.print("\f"); // Konsole leeren
    BinaererSuchbaum<Integer> b = new BinaererSuchbaum();
    //b.erstelleBaumAusListe("7 10 6 12 8 4 9 24");
    b.erstelleBaumAusListe("15 3 0 7 5 9 33 16 37");
    System.out.print("\n Inorder: ");
    b.ausgebenDatenInorder();
    System.out.print("\n Preorder: ");
    b.ausgebenDatenPreorder();
    System.out.print("\n Postorder: ");
    b.ausgebenDatenPostorder();
    System.out.print("\n Höhe: ");
    System.out.println(b.gibWurzel().gibHoehe());
    System.out.print("\n Levelorder: ");
    b.gibWurzel().ausgebenDatenLevelorder();
    System.out.println();
    b.gibWurzel().ausgebenBaum();
    b.ausgeben2D();
    System.out.println("Element 10 enthalten: "+(b.gibWurzel().enthaltenElement(10) ? "Ja":"Nein"));
    System.out.println("Element 16 enthalten: "+(b.gibWurzel().enthaltenElement(16) ? "Ja":"Nein"));
    System.out.println("Tiefe von 9: "+ b.gibWurzel().returnTiefe(9));
    System.out.println("Tiefe von 34: "+ b.gibWurzel().returnTiefe(34));
    System.out.println("Pfad zu 9: "+ b.gibWurzel().returnPfad(9));
    System.out.println("Pfad zu 34: "+ b.gibWurzel().returnPfad(34));
    System.out.println("Minimum: "+ b.gibWurzel().returnMin());
    System.out.println("Maximum: "+ b.gibWurzel().returnMax());
  }

  public static void testeOptEinfuegen(){
    System.out.print("\f"); // Konsole leeren
    BinaererSuchbaum<Integer> b = new BinaererSuchbaum();
    b.erstelleBaumAusListeOptimal2("15 3 0 7 5 9 33 16 37");
  }
}