import java.util.ArrayList;
public class Knoten <Typ>{
  private int inhalt; // Typ inhalt
  private Knoten<Typ> linkerTeilbaum;
  private Knoten<Typ> rechterTeilbaum;
  public Knoten(int e){ //Typ e
    inhalt = e;    
  }

  public int gibInhalt(){
    return inhalt;
  }

  public Knoten <Typ> gibLinkenTeilbaum(){
    return linkerTeilbaum;
  }

  public Knoten <Typ> gibRechtenTeilbaum(){
    return rechterTeilbaum;
  }

  public void setzeLinkenTeilbaum(Knoten <Typ> k){
    linkerTeilbaum = k;
  }

  public void setzeRechtenTeilbaum(Knoten <Typ> k){
    rechterTeilbaum = k;
  } 

  public boolean istBlatt(){
    return linkerTeilbaum==null && rechterTeilbaum==null;
  }

  public String returnDatenInorder(){ // gibt String in Inorder zurueck
    String s="";
    if(linkerTeilbaum != null){
      s+= linkerTeilbaum.returnDatenInorder();
    }
    s+= inhalt +" ";
    if(rechterTeilbaum != null){
      s+=rechterTeilbaum.returnDatenInorder();
    }
    return s;
  }

  public void ausgebenDatenPreorder(){
    System.out.print(inhalt+" "); // inhalt.ausgebenDaten()
    if(linkerTeilbaum != null){
      linkerTeilbaum.ausgebenDatenPreorder();
    }
    if(rechterTeilbaum != null){
      rechterTeilbaum.ausgebenDatenPreorder();
    }
  }

  public void ausgebenDatenPostorder(){
    if(linkerTeilbaum != null){
      linkerTeilbaum.ausgebenDatenPostorder();
    }
    if(rechterTeilbaum != null){
      rechterTeilbaum.ausgebenDatenPostorder();
    }
    System.out.print(inhalt+" "); // inhalt.ausgebenDaten()
  }

  public int gibHoehe(){
    int h=-1;
    if(linkerTeilbaum != null){
      if (h<linkerTeilbaum.gibHoehe())h=linkerTeilbaum.gibHoehe();
    }
    if(rechterTeilbaum != null){
      if (h<rechterTeilbaum.gibHoehe())h=rechterTeilbaum.gibHoehe();
    }
    return h+1;
  }

  public void ausgebenDatenLevelorder(){ // Ebene fuer Ebene ausgeben
    ArrayList <Knoten> schlange = new ArrayList<>(); // fuer Levelorder-Ausgabe
    Knoten k;
    schlange.add(this);
    while (!schlange.isEmpty()){
      k=schlange.remove(0); // hole den ersten Knoten
      System.out.print(k.gibInhalt()+" "); // Knoteninhalt ausgeben.
      if(k.gibLinkenTeilbaum() != null){
        schlange.add(k.gibLinkenTeilbaum());
      }
      if(k.gibRechtenTeilbaum() != null){
        schlange.add(k.gibRechtenTeilbaum());
      }
    }
  }

  public void ausgebenBaum(){ // Auf Konsole ausgeben
    ArrayList <Knoten> ebeneOben = new ArrayList<>(); // Schlange
    ArrayList <Knoten> ebeneUnten;
    int i,h,l,hoehe,leerzeichen;
    ebeneOben.add(this);
    hoehe = gibHoehe();
    leerzeichen = (int)Math.pow(2,hoehe);
    for(h=0;h<=hoehe;h++){ // alle Ebenen ausgeben
      ebeneUnten= new ArrayList<>(); // darunterliegende Ebene
      for (i=0;i<ebeneOben.size();i++){ // alle Knoten der Ebene
        for(l=0;l<leerzeichen;l++)System.out.print("  "); // Einruecken
        if(ebeneOben.get(i)!=null){
          System.out.printf("%2d",ebeneOben.get(i).gibInhalt());
          ebeneUnten.add(ebeneOben.get(i).gibLinkenTeilbaum());
          ebeneUnten.add(ebeneOben.get(i).gibRechtenTeilbaum());
        }
        else{
          System.out.print("  ");
          ebeneUnten.add(null); // Dummys hinzufuegen
          ebeneUnten.add(null);
        }
        for(l=0;l<leerzeichen-1;l++)System.out.print("  ");
      }
      System.out.println();
      ebeneOben=ebeneUnten;
      leerzeichen/=2; // halb so viel einruecken
    }
  }

  public void baumAusgeben2D(String praefix, boolean istLinks, boolean istOberster) { // Danke Sabine
    // Rechten Teilbaum ausgeben
    if (rechterTeilbaum != null) {
      if (istLinks && !istOberster)
        rechterTeilbaum.baumAusgeben2D(praefix + "|   ", false, false); // Richtungsumkehr --> Strich zeichnen
      else 
        rechterTeilbaum.baumAusgeben2D(praefix + "    ", false, false);
    }

    // Knoten selbst ausgeben
    if (istLinks)
      System.out.println(praefix + "└── " + gibInhalt());
    else if (istOberster)
      System.out.println(praefix + "─── " + gibInhalt());
    else 
      System.out.println(praefix + "┌── " + gibInhalt());

    // Linken Teilbaum ausgeben
    if (linkerTeilbaum != null) {
      if (istLinks || istOberster)
        linkerTeilbaum.baumAusgeben2D(praefix + "    ", true, false);
      else 
        linkerTeilbaum.baumAusgeben2D(praefix + "|   ", true, false); // Richtungsumkehr --> Strich zeichnen
    }
  }

  public boolean enthaltenElement(int e){ //Typ e
    if(inhalt==e) return true;
    if(linkerTeilbaum!=null && linkerTeilbaum.enthaltenElement(e)
    || rechterTeilbaum!=null && rechterTeilbaum.enthaltenElement(e)) return true;
    return false;
  }

  public void einfuegenElement(int e){ // sortiertes Einfuegen
    if(inhalt==e){
      System.out.println("Element schon enthalten: "+e);
    }
    else{
      if(e < inhalt){
        if(linkerTeilbaum==null){
          linkerTeilbaum= new Knoten(e);
        }
        else linkerTeilbaum.einfuegenElement(e);
      }
      else{
        if(rechterTeilbaum==null){
          rechterTeilbaum= new Knoten(e);
        }
        else rechterTeilbaum.einfuegenElement(e);
      }
    }
  }

  public int returnMin(){
    if(linkerTeilbaum==null) return inhalt;
    return linkerTeilbaum.returnMin();
  }

  public int returnMax(){
    if(rechterTeilbaum==null) return inhalt;
    return rechterTeilbaum.returnMax();
  }

  public int returnTiefe(int e){ //Typ e
    int t;
    if(inhalt==e) return 0;
    if(e<inhalt && linkerTeilbaum!=null){
      t=linkerTeilbaum.returnTiefe(e);
      if(t<0)return-1;
      return 1+t;
    }
    else{
      if(rechterTeilbaum!=null){
        t=rechterTeilbaum.returnTiefe(e);
        if(t<0)return-1;
        return 1+t;
      }
    }
    return -1;
  }

  public String returnPfad(int e){ //Typ e
    String s ="";
    s+=inhalt;
    if(inhalt==e) return s;
    if(e<inhalt && linkerTeilbaum!=null){
      return s+=" "+linkerTeilbaum.returnPfad(e);
    }
    else{
      if(rechterTeilbaum!=null){
        return s+=" "+rechterTeilbaum.returnPfad(e);
      }
    }
    return "Nicht gefunden";
  }
}